Subject: Re: [PATCH bpf-next v7 03/10] bpf: verifier: refactor check_attach_btf_id()

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Tue, 22 Sep 2020 12:14:10 +0200

Andrii Nakryiko <[email-masked]> writes:

> On Sat, Sep 19, 2020 at 4:50 AM Toke Høiland-Jørgensen <[email-masked]> wrote:
>>
>> From: Toke Høiland-Jørgensen <[email-masked]>
>>
>> The check_attach_btf_id() function really does three things:
>>
>> 1. It performs a bunch of checks on the program to ensure that the
>>    attachment is valid.
>>
>> 2. It stores a bunch of state about the attachment being requested in
>>    the verifier environment and struct bpf_prog objects.
>>
>> 3. It allocates a trampoline for the attachment.
>>
>> This patch splits out (1.) and (3.) into separate functions in preparation
>> for reusing them when the actual attachment is happening (in the
>> raw_tracepoint_open syscall operation), which will allow tracing programs
>> to have multiple (compatible) attachments.
>>
>> No functional change is intended with this patch.
>>
>> Acked-by: Andrii Nakryiko <[email-masked]>
>> Signed-off-by: Toke Høiland-Jørgensen <[email-masked]>
>> ---
>
> Ok, so bad news: you broke another selftest (test_overhead). Please,
> do run test_progs and make sure everything succeeds, every time before
> you post a new version.

Ah, right, I'll take a look. I have had some trouble with running all
the tests because my VM runs out of memory, so I was picking and
choosing. Guess I'll go and actually fix this and run the full test
suite...

> Good news, though, is that this refactoring actually fixed a pretty
> nasty bug in check_attach_btf_id logic: whenever bpf_trampoline
> already existed (e.g., due to successful fentry to function X), all
> subsequent fentry/fexit/fmod_ret and all their sleepable variants
> would skip a bunch of check. So please attach the following Fixes
> tags:
>
> Fixes: 6ba43b761c41 ("bpf: Attachment verification for BPF_MODIFY_RETURN")
> Fixes: 1e6c62a88215 ("bpf: Introduce sleepable BPF programs")

Ah, yes, well spotted! Will add the Fixes tags :)

> As for selftests, feel free to just drop the fmod_ret program, it was
> never supposed to be possible, I just never realized that.

Well, doesn't hurt to have it, does it? If you don't mind I think I'll
just keep it...

-Toke